(* Author:  Robbert van Renesse, Cornell University.
 *
 * Shared stuff.
 *)

type constr
	= CCONST of string
	| NCCONST of (string * t)
and t
	= ALPHA_TYPE of string
	| FUNCTION_TYPE of (t list * t)
	| PRODUCT_TYPE of t list
	| NAMED_TYPE of ((string * string) * (t list))
	| CONSTR_TYPE of constr list
	| STRUCT_TYPE of (string * bool * t) list
	| ABSTRACT_TYPE

type decl
	= TYPE_DECL of (string * (string list)) * t
	| VAL_DECL of string * t
	| EXTTYPE_DECL of string * string * t
	| EXTVAL_DECL of string * string * t
	| EXCEPTION_DECL of constr list
	| INCLUDE_DECL of (string * string)
